

#pragma once
#pragma warning( disable : 4786 )  
#pragma warning( disable : 4099 )  

#include "../debugging/Debug.h"					//Debugger Functionality
#include "../nexception/Nexception.h"			//For exceptions
#include "../messageHandler/MessageHandler.h"	//Note: The AI system interfaces to the game via the Message Handler
#include "../timeObject/Timer.h"
#include "../fileIO/memento.h"

#include <algorithm>
#include <vector>
#include <map>
#include <list>
#include <set>

//Forward declarations
namespace AI_System
{
	class AI_PerceptGenerator;
	class AI_Action;
	class AI_ADN;
	class AI_BrainManager;
	class AI_DFTest_A;
	class AI_DFTest_B;
	class BayesADN;
}

#include "AI_Keys.h"
#include "AI_Attribute_Action.h"
#include "AI_DataFilterBase.h"
#include "AI_FitnessFunctionBase.h"
#include "AI_HigherGoalBase.h"
#include "AI_PerceptGenerator.h"
//#include "AI_Config.h"
#include "AI_AIUnitBase.h"
#include "AI_ADNBase.h"
#include "AI_Helpers.h"
#include "AI_TestUnit.h"
#include "AI_TestADN.h"
#include "AI_Module.h"
#include "AI_GeneticAlgorithm.h"
#include "AI_BrainManager.h"

#include "dataFilters/AI_DataFilters.h"
#include "fitnessFunctions/AI_FitnessFunctions.h"
#include "fitnessFunctions/AI_HigherGoals.h"
#include "bayes_classifier/BayesClassifier.h"
#include "bayes_classifier/BayesADN.h"
#include "bayes_classifier/BayesUnit.h"
#include "dTrees/C45.hpp"
#include "neuralNetwork/NeuralNetwork.h"
#include "neuralNetwork/NeuralUnit.h"
#include "neuralNetwork/NeuralADN.h"
