#pragma once
#include "../AI_System.h"


namespace AI_System
{

	namespace FitnessFunctions
	{
		extern const float FITNESS_BOUNDRY;		//!< If less then this value result
												//!<  will be set to false in several
												//!<  FitnessFunctions.


		////////////////////////////////////////////////////////////////////////////////
		/*!	\class		MaxHealth
		**	\brief		Fitness function that maxs the fish's health.
		**	\author		Nate Cleveland
		**	\date		11/27/2002 2:08:21 PM
		**	\warning	none
		*/
		////////////////////////////////////////////////////////////////////////////////
		class MaxHealth: public AI_System::AI_FitnessFunction
		{
		public:
			MaxHealth()throw();
			bool evaluateFitness(bool fitnessReturned = false, float prevFitness = 0.0f);
		};



		////////////////////////////////////////////////////////////////////////////////
		/*!	\class		MaxStomach
		**	\brief		Fitness function that maxs the fish's Stomach.
		**	\author		Nate Cleveland
		**	\date		11/27/2002 2:08:21 PM
		**	\warning	none
		*/
		////////////////////////////////////////////////////////////////////////////////
		class MaxStomach: public AI_System::AI_FitnessFunction
		{
		public:
			MaxStomach()throw();
			bool evaluateFitness(bool fitnessReturned = false, float prevFitness = 0.0f);
		};





		////////////////////////////////////////////////////////////////////////////////
		/*!	\class		MaxSpeed
		**	\brief		Fitness function that maxs the fish's Speed.
		**	\author		Nate Cleveland
		**	\date		11/27/2002 2:08:21 PM
		**	\warning	none
		*/
		////////////////////////////////////////////////////////////////////////////////
		class MaxSpeed: public AI_System::AI_FitnessFunction
		{
		public:
			MaxSpeed()throw();
			bool evaluateFitness(bool fitnessReturned = false, float prevFitness = 0.0f);
		};



		////////////////////////////////////////////////////////////////////////////////
		/*!	\class		MaxEnergyLevel
		**	\brief		Fitness function that maxs the fish's EnergyLevel.
		**	\author		Nate Cleveland
		**	\date		11/27/2002 2:08:21 PM
		**	\warning	none
		*/
		////////////////////////////////////////////////////////////////////////////////
		class MaxEnergyLevel: public AI_System::AI_FitnessFunction
		{
		public:
			MaxEnergyLevel() throw();
			bool evaluateFitness(bool fitnessReturned = false, float prevFitness = 0.0f);
		};



		////////////////////////////////////////////////////////////////////////////////
		/*!	\class		MaxIncline
		**	\brief		Fitness function that maxs the fish's Incline.
		**	\author		Nate Cleveland
		**	\date		11/27/2002 2:08:21 PM
		**	\warning	none
		*/
		////////////////////////////////////////////////////////////////////////////////
		class MaxIncline: public AI_System::AI_FitnessFunction
		{
		public:
			MaxIncline() throw();
			bool evaluateFitness(bool fitnessReturned = false, float prevFitness = 0.0f);
		};



		////////////////////////////////////////////////////////////////////////////////
		/*!	\class		MaxSpeedEnergy
		**	\brief		Fitness function that maxs the fish's SpeedEnergy.
		**	\author		Nate Cleveland
		**	\date		11/27/2002 2:08:21 PM
		**	\warning	none
		*/
		////////////////////////////////////////////////////////////////////////////////
		class MaxSpeedEnergy: public AI_System::AI_FitnessFunction
		{
		public:
			MaxSpeedEnergy() throw();
			bool evaluateFitness(bool fitnessReturned = false, float prevFitness = 0.0f);
		};



		////////////////////////////////////////////////////////////////////////////////
		/*!	\class		MaxStomachHealth
		**	\brief		Fitness function that max's the fish's StomachHealth.
		**	\author		Nate Cleveland
		**	\date		11/27/2002 2:08:21 PM
		**	\warning	none
		*/
		////////////////////////////////////////////////////////////////////////////////
		class MaxStomachHealth: public AI_System::AI_FitnessFunction
		{
		public:
			MaxStomachHealth() throw();
			bool evaluateFitness(bool fitnessReturned = false, float prevFitness = 0.0f);
		};




		////////////////////////////////////////////////////////////////////////////////
		/*!	\class		MinBeenAttacked
		**	\brief		Fitness function that minimizes how often a fish is attacked
		**	\author		Nate Cleveland
		**	\date		11/27/2002 2:08:21 PM
		**	\warning	none
		*/
		////////////////////////////////////////////////////////////////////////////////
		class MinBeenAttacked: public AI_System::AI_FitnessFunction
		{
		public:
			MinBeenAttacked() throw();
			bool evaluateFitness(bool fitnessReturned = false, float prevFitness = 0.0f);
		};



		////////////////////////////////////////////////////////////////////////////////
		/*!	\class		MaxPlankton
		**	\brief		Fitness function that maximizes how much plankton has eaten.
		**	\author		Nate Cleveland
		**	\date		11/27/2002 2:08:21 PM
		**	\warning	none
		*/
		////////////////////////////////////////////////////////////////////////////////
		class MaxPlankton: public AI_System::AI_FitnessFunction
		{
		public:
			MaxPlankton() throw();
			bool evaluateFitness(bool fitnessReturned = false, float prevFitness = 0.0f);
		};	



		////////////////////////////////////////////////////////////////////////////////
		/*!	\class		MaxDistance
		**	\brief		Fitness function that emphasizes avoiding fish.
		**	\author		Nate Cleveland
		**	\date		11/27/2002 2:08:21 PM
		**	\warning	none
		*/
		////////////////////////////////////////////////////////////////////////////////
		class MaxDistance: public AI_System::AI_FitnessFunction
		{
		public:
			MaxDistance() throw();
			bool evaluateFitness(bool fitnessReturned = false, float prevFitness = 0.0f);
		};



		////////////////////////////////////////////////////////////////////////////////
		/*!	\class		MinDistance
		**	\brief		Fitness function that emphasizes being near fish.
		**	\author		Nate Cleveland
		**	\date		11/27/2002 2:08:21 PM
		**	\warning	none
		*/
		////////////////////////////////////////////////////////////////////////////////
		class MinDistance: public AI_System::AI_FitnessFunction
		{
		public:
			MinDistance() throw();
			bool evaluateFitness(bool fitnessReturned = false, float prevFitness = 0.0f);
		};



		////////////////////////////////////////////////////////////////////////////////
		/*!	\class		MaxChum
		**	\brief		Fitness function that tries to max chum rate
		**	\author		Nate Cleveland
		**	\date		11/27/2002 2:08:21 PM
		**	\warning	none
		*/
		////////////////////////////////////////////////////////////////////////////////
		class MaxChum: public AI_System::AI_FitnessFunction
		{
		public:
			MaxChum() throw();
			bool evaluateFitness(bool fitnessReturned = false, float prevFitness = 0.0f);
		};



		////////////////////////////////////////////////////////////////////////////////
		/*!	\class		PlanktonDensity
		**	\brief		Analizes plankton density, likes to be in dense places.
		**	\author		Nate Cleveland
		**	\date		11/27/2002 2:08:21 PM
		**	\warning	none
		*/
		////////////////////////////////////////////////////////////////////////////////
		class PlanktonDensity: public AI_System::AI_FitnessFunction
		{
		public:
			PlanktonDensity() throw();
			bool evaluateFitness(bool fitnessReturned = false, float prevFitness = 0.0f);
		};
	}//end namespace FitnessFunctions
}//end namespace AI_System