////////////////////////////////////////////////////////////////////////////////
/*! \file       gfx.h
**  \brief      Graphics Module Include
**  \author     M Jared Finder
**  \date       10/8/2002 7:34:58 PM
**  \par        DESCRIPTION:
**                  Include this to get access to the entired graphics module.
*/
////////////////////////////////////////////////////////////////////////////////
#pragma once


///Everything in the graphics engine's namespace
#include "gfx/exception.h"      ///< exceptions used

#include "gfx/structs.h"        ///< generic structures used
#include "gfx/renderer.h"       ///< graphics renderer
#include "gfx/renderable.h"     ///< client bases

#include "gfx/model.h"          ///< static models
#include "gfx/anim_model.h"     ///< animated models
#include "gfx/multi_model.h"    ///< multiple models blended together
#include "gfx/texture.h"        ///< simple 2d textures
#include "gfx/sub_texture.h"    ///< sub-2d textures
#include "gfx/font.h"           ///< font textures
#include "gfx/wide_font.h"      ///< wide-character fonts
#include "gfx/sprite.h"         ///< 2d sprites
#include "gfx/sprite_3d.h"      ///< 3d sprites (point sprites)
