////////////////////////////////////////////////////////////////////////////////
/*! \file       gfx/opengl.cpp
**  \brief      Stores the function pointers for OpenGL procedures.
**  \author     M Jared Finder
**  \date       2/15/2003 2:58:35 PM
*/
////////////////////////////////////////////////////////////////////////////////
#include"gfx/opengl.h"
// memory leak detection
#ifdef _DEBUG
    #include"memleak.h"
    #define new DEBUG_NEW
    #undef THIS_FILE
    static char THIS_FILE[] = __FILE__;
#endif


////////////////////////////////////////////////////////////////////////////////
// Needed includes
////////////////////////////////////////////////////////////////////////////////
//#include"stdheaders.h"


////////////////////////////////////////////////////////////////////////////////
// OpenGL 1.0 functions
////////////////////////////////////////////////////////////////////////////////
// already implemented in gl/gl.h


////////////////////////////////////////////////////////////////////////////////
// OpenGL 1.1 functions
////////////////////////////////////////////////////////////////////////////////
// already implemented in gl/gl.h


////////////////////////////////////////////////////////////////////////////////
// OpenGL 1.2 functions
////////////////////////////////////////////////////////////////////////////////
PFNGLBLENDCOLORPROC                  glBlendColor                       = NULL;
PFNGLBLENDEQUATIONPROC               glBlendEquation                    = NULL;
PFNGLDRAWRANGEELEMENTSPROC           glDrawRangeElements                = NULL;
PFNGLCOLORTABLEPROC                  glColorTable                       = NULL;
PFNGLCOLORTABLEPARAMETERFVPROC       glColorTableParameterfv            = NULL;
PFNGLCOLORTABLEPARAMETERIVPROC       glColorTableParameteriv            = NULL;
PFNGLCOPYCOLORTABLEPROC              glCopyColorTable                   = NULL;
PFNGLGETCOLORTABLEPROC               glGetColorTable                    = NULL;
PFNGLGETCOLORTABLEPARAMETERFVPROC    glGetColorTableParameterfv         = NULL;
PFNGLGETCOLORTABLEPARAMETERIVPROC    glGetColorTableParameteriv         = NULL;
PFNGLCOLORSUBTABLEPROC               glColorSubTable                    = NULL;
PFNGLCOPYCOLORSUBTABLEPROC           glCopyColorSubTable                = NULL;
PFNGLCONVOLUTIONFILTER1DPROC         glConvolutionFilter1D              = NULL;
PFNGLCONVOLUTIONFILTER2DPROC         glConvolutionFilter2D              = NULL;
PFNGLCONVOLUTIONPARAMETERFPROC       glConvolutionParameterf            = NULL;
PFNGLCONVOLUTIONPARAMETERFVPROC      glConvolutionParameterfv           = NULL;
PFNGLCONVOLUTIONPARAMETERIPROC       glConvolutionParameteri            = NULL;
PFNGLCONVOLUTIONPARAMETERIVPROC      glConvolutionParameteriv           = NULL;
PFNGLCOPYCONVOLUTIONFILTER1DPROC     glCopyConvolutionFilter1D          = NULL;
PFNGLCOPYCONVOLUTIONFILTER2DPROC     glCopyConvolutionFilter2D          = NULL;
PFNGLGETCONVOLUTIONFILTERPROC        glGetConvolutionFilter             = NULL;
PFNGLGETCONVOLUTIONPARAMETERFVPROC   glGetConvolutionParameterfv        = NULL;
PFNGLGETCONVOLUTIONPARAMETERIVPROC   glGetConvolutionParameteriv        = NULL;
PFNGLGETSEPARABLEFILTERPROC          glGetSeparableFilter               = NULL;
PFNGLSEPARABLEFILTER2DPROC           glSeparableFilter2D                = NULL;
PFNGLGETHISTOGRAMPROC                glGetHistogram                     = NULL;
PFNGLGETHISTOGRAMPARAMETERFVPROC     glGetHistogramParameterfv          = NULL;
PFNGLGETHISTOGRAMPARAMETERIVPROC     glGetHistogramParameteriv          = NULL;
PFNGLGETMINMAXPROC                   glGetMinmax                        = NULL;
PFNGLGETMINMAXPARAMETERFVPROC        glGetMinmaxParameterfv             = NULL;
PFNGLGETMINMAXPARAMETERIVPROC        glGetMinmaxParameteriv             = NULL;
PFNGLHISTOGRAMPROC                   glHistogram                        = NULL;
PFNGLMINMAXPROC                      glMinmax                           = NULL;
PFNGLRESETHISTOGRAMPROC              glResetHistogram                   = NULL;
PFNGLRESETMINMAXPROC                 glResetMinmax                      = NULL;
PFNGLTEXIMAGE3DPROC                  glTexImage3D                       = NULL;
PFNGLTEXSUBIMAGE3DPROC               glTexSubImage3D                    = NULL;
PFNGLCOPYTEXSUBIMAGE3DPROC           glCopyTexSubImage3D                = NULL;


////////////////////////////////////////////////////////////////////////////////
// OpenGL 1.3 functions
////////////////////////////////////////////////////////////////////////////////
PFNGLACTIVETEXTUREPROC               glActiveTexture                    = NULL;
PFNGLCLIENTACTIVETEXTUREPROC         glClientActiveTexture              = NULL;
PFNGLMULTITEXCOORD1DPROC             glMultiTexCoord1d                  = NULL;
PFNGLMULTITEXCOORD1DVPROC            glMultiTexCoord1dv                 = NULL;
PFNGLMULTITEXCOORD1FPROC             glMultiTexCoord1f                  = NULL;
PFNGLMULTITEXCOORD1FVPROC            glMultiTexCoord1fv                 = NULL;
PFNGLMULTITEXCOORD1IPROC             glMultiTexCoord1i                  = NULL;
PFNGLMULTITEXCOORD1IVPROC            glMultiTexCoord1iv                 = NULL;
PFNGLMULTITEXCOORD1SPROC             glMultiTexCoord1s                  = NULL;
PFNGLMULTITEXCOORD1SVPROC            glMultiTexCoord1sv                 = NULL;
PFNGLMULTITEXCOORD2DPROC             glMultiTexCoord2d                  = NULL;
PFNGLMULTITEXCOORD2DVPROC            glMultiTexCoord2dv                 = NULL;
PFNGLMULTITEXCOORD2FPROC             glMultiTexCoord2f                  = NULL;
PFNGLMULTITEXCOORD2FVPROC            glMultiTexCoord2fv                 = NULL;
PFNGLMULTITEXCOORD2IPROC             glMultiTexCoord2i                  = NULL;
PFNGLMULTITEXCOORD2IVPROC            glMultiTexCoord2iv                 = NULL;
PFNGLMULTITEXCOORD2SPROC             glMultiTexCoord2s                  = NULL;
PFNGLMULTITEXCOORD2SVPROC            glMultiTexCoord2sv                 = NULL;
PFNGLMULTITEXCOORD3DPROC             glMultiTexCoord3d                  = NULL;
PFNGLMULTITEXCOORD3DVPROC            glMultiTexCoord3dv                 = NULL;
PFNGLMULTITEXCOORD3FPROC             glMultiTexCoord3f                  = NULL;
PFNGLMULTITEXCOORD3FVPROC            glMultiTexCoord3fv                 = NULL;
PFNGLMULTITEXCOORD3IPROC             glMultiTexCoord3i                  = NULL;
PFNGLMULTITEXCOORD3IVPROC            glMultiTexCoord3iv                 = NULL;
PFNGLMULTITEXCOORD3SPROC             glMultiTexCoord3s                  = NULL;
PFNGLMULTITEXCOORD3SVPROC            glMultiTexCoord3sv                 = NULL;
PFNGLMULTITEXCOORD4DPROC             glMultiTexCoord4d                  = NULL;
PFNGLMULTITEXCOORD4DVPROC            glMultiTexCoord4dv                 = NULL;
PFNGLMULTITEXCOORD4FPROC             glMultiTexCoord4f                  = NULL;
PFNGLMULTITEXCOORD4FVPROC            glMultiTexCoord4fv                 = NULL;
PFNGLMULTITEXCOORD4IPROC             glMultiTexCoord4i                  = NULL;
PFNGLMULTITEXCOORD4IVPROC            glMultiTexCoord4iv                 = NULL;
PFNGLMULTITEXCOORD4SPROC             glMultiTexCoord4s                  = NULL;
PFNGLMULTITEXCOORD4SVPROC            glMultiTexCoord4sv                 = NULL;
PFNGLLOADTRANSPOSEMATRIXFPROC        glLoadTransposeMatrixf             = NULL;
PFNGLLOADTRANSPOSEMATRIXDPROC        glLoadTransposeMatrixd             = NULL;
PFNGLMULTTRANSPOSEMATRIXFPROC        glMultTransposeMatrixf             = NULL;
PFNGLMULTTRANSPOSEMATRIXDPROC        glMultTransposeMatrixd             = NULL;
PFNGLSAMPLECOVERAGEPROC              glSampleCoverage                   = NULL;
PFNGLCOMPRESSEDTEXIMAGE3DPROC        glCompressedTexImage3D             = NULL;
PFNGLCOMPRESSEDTEXIMAGE2DPROC        glCompressedTexImage2D             = NULL;
PFNGLCOMPRESSEDTEXIMAGE1DPROC        glCompressedTexImage1D             = NULL;
PFNGLCOMPRESSEDTEXSUBIMAGE3DPROC     glCompressedTexSubImage3D          = NULL;
PFNGLCOMPRESSEDTEXSUBIMAGE2DPROC     glCompressedTexSubImage2D          = NULL;
PFNGLCOMPRESSEDTEXSUBIMAGE1DPROC     glCompressedTexSubImage1D          = NULL;
PFNGLGETCOMPRESSEDTEXIMAGEPROC       glGetCompressedTexImage            = NULL;


////////////////////////////////////////////////////////////////////////////////
// OpenGL ARB functions
////////////////////////////////////////////////////////////////////////////////
//14.   GL_ARB_point_parameters
PFNGLPOINTPARAMETERFARBPROC          glPointParameterfARB               = NULL;
PFNGLPOINTPARAMETERFVARBPROC         glPointParameterfvARB              = NULL;
//15.   GL_ARB_vertex_blend
PFNGLWEIGHTBVARBPROC                 glWeightbvARB                      = NULL;
PFNGLWEIGHTSVARBPROC                 glWeightsvARB                      = NULL;
PFNGLWEIGHTIVARBPROC                 glWeightivARB                      = NULL;
PFNGLWEIGHTFVARBPROC                 glWeightfvARB                      = NULL;
PFNGLWEIGHTDVARBPROC                 glWeightdvARB                      = NULL;
PFNGLWEIGHTUBVARBPROC                glWeightubvARB                     = NULL;
PFNGLWEIGHTUSVARBPROC                glWeightusvARB                     = NULL;
PFNGLWEIGHTUIVARBPROC                glWeightuivARB                     = NULL;
PFNGLWEIGHTPOINTERARBPROC            glWeightPointerARB                 = NULL;
PFNGLVERTEXBLENDARBPROC              glVertexBlendARB                   = NULL;
//16.   GL_ARB_matrix_palette
PFNGLCURRENTPALETTEMATRIXARBPROC     glCurrentPaletteMatrixARB          = NULL;
PFNGLMATRIXINDEXUBVARBPROC           glMatrixIndexubvARB                = NULL;
PFNGLMATRIXINDEXUSVARBPROC           glMatrixIndexusvARB                = NULL;
PFNGLMATRIXINDEXUIVARBPROC           glMatrixIndexuivARB                = NULL;
PFNGLMATRIXINDEXPOINTERARBPROC       glMatrixIndexPointerARB            = NULL;
//18.   GL_ARB_texture_env_crossbar
//21.   GL_ARB_texture_mirrored_repeat
//22.   GL_ARB_depth_texture
//23.   GL_ARB_shadow
//24.   GL_ARB_shadow_ambient
//25.   GL_ARB_window_pos
PFNGLWINDOWPOS2DARBPROC              glWindowPos2dARB                   = NULL;
PFNGLWINDOWPOS2DVARBPROC             glWindowPos2dvARB                  = NULL;
PFNGLWINDOWPOS2FARBPROC              glWindowPos2fARB                   = NULL;
PFNGLWINDOWPOS2FVARBPROC             glWindowPos2fvARB                  = NULL;
PFNGLWINDOWPOS2IARBPROC              glWindowPos2iARB                   = NULL;
PFNGLWINDOWPOS2IVARBPROC             glWindowPos2ivARB                  = NULL;
PFNGLWINDOWPOS2SARBPROC              glWindowPos2sARB                   = NULL;
PFNGLWINDOWPOS2SVARBPROC             glWindowPos2svARB                  = NULL;
PFNGLWINDOWPOS3DARBPROC              glWindowPos3dARB                   = NULL;
PFNGLWINDOWPOS3DVARBPROC             glWindowPos3dvARB                  = NULL;
PFNGLWINDOWPOS3FARBPROC              glWindowPos3fARB                   = NULL;
PFNGLWINDOWPOS3FVARBPROC             glWindowPos3fvARB                  = NULL;
PFNGLWINDOWPOS3IARBPROC              glWindowPos3iARB                   = NULL;
PFNGLWINDOWPOS3IVARBPROC             glWindowPos3ivARB                  = NULL;
PFNGLWINDOWPOS3SARBPROC              glWindowPos3sARB                   = NULL;
PFNGLWINDOWPOS3SVARBPROC             glWindowPos3svARB                  = NULL;


////////////////////////////////////////////////////////////////////////////////
// OpenGL EXT functions
////////////////////////////////////////////////////////////////////////////////
//97.   GL_EXT_compiled_vertex_array
PFNGLLOCKARRAYSEXTPROC               glLockArraysEXT                    = NULL;
PFNGLUNLOCKARRAYSEXTPROC             glUnlockArraysEXT                  = NULL;


////////////////////////////////////////////////////////////////////////////////
// OpenGL NV functions
////////////////////////////////////////////////////////////////////////////////
///190. GL_NV_vertex_array_range
PFNWGLALLOCATEMEMORYNVPROC           wglAllocateMemoryNV                = NULL;
PFNWGLFREEMEMORYNVPROC               wglFreeMemoryNV                    = NULL;
PFNGLFLUSHVERTEXARRAYRANGENVPROC     glFlushVertexArrayRangeNV          = NULL;
PFNGLVERTEXARRAYRANGENVPROC          glVertexArrayRangeNV               = NULL;
///262. GL_NV_point_sprite
PFNGLPOINTPARAMETERINVPROC           glPointParameteriNV                = NULL;
PFNGLPOINTPARAMETERIVNVPROC          glPointParameterivNV               = NULL;



////////////////////////////////////////////////////////////////////////////////
// OpenGL ATI functions
////////////////////////////////////////////////////////////////////////////////
///247. GL_ATI_vertex_array_object
PFNGLNEWOBJECTBUFFERATIPROC          glNewObjectBufferATI               = NULL;
PFNGLISOBJECTBUFFERATIPROC           glIsObjectBufferATI                = NULL;
PFNGLUPDATEOBJECTBUFFERATIPROC       glUpdateObjectBufferATI            = NULL;
PFNGLGETOBJECTBUFFERFVATIPROC        glGetObjectBufferfvATI             = NULL;
PFNGLGETOBJECTBUFFERIVATIPROC        glGetObjectBufferivATI             = NULL;
PFNGLDELETEOBJECTBUFFERATIPROC       glDeleteObjectBufferATI            = NULL;
PFNGLARRAYOBJECTATIPROC              glArrayObjectATI                   = NULL;
PFNGLGETARRAYOBJECTFVATIPROC         glGetArrayObjectfvATI              = NULL;
PFNGLGETARRAYOBJECTIVATIPROC         glGetArrayObjectivATI              = NULL;
PFNGLVARIANTARRAYOBJECTATIPROC       glVariantArrayObjectATI            = NULL;
PFNGLGETVARIANTARRAYOBJECTFVATIPROC  glGetVariantArrayObjectfvATI       = NULL;
PFNGLGETVARIANTARRAYOBJECTIVATIPROC  glGetVariantArrayObjectivATI       = NULL;