////////////////////////////////////////////////////////////////////////////////
/*! \file       gfx/opengl.h
**  \brief      Includes for OpenGL graphics subsystem.
**  \author     M Jared Finder
**  \date       2/15/2003 11:16:24 AM
*/
////////////////////////////////////////////////////////////////////////////////
#pragma once


////////////////////////////////////////////////////////////////////////////////
// Forward Declarations and needed includes
////////////////////////////////////////////////////////////////////////////////
#define WIN32_LEAN_AND_MEAN
#include<windows.h>
#include<gl/gl.h>
#include<gl/glu.h>
#include<gl/glext.h>
#include<gl/wglext.h>


////////////////////////////////////////////////////////////////////////////////
// OpenGL 1.0 functions
////////////////////////////////////////////////////////////////////////////////
// already implemented in gl/gl.h


////////////////////////////////////////////////////////////////////////////////
// OpenGL 1.1 functions
////////////////////////////////////////////////////////////////////////////////
// already implemented in gl/gl.h


////////////////////////////////////////////////////////////////////////////////
// OpenGL 1.2 functions
////////////////////////////////////////////////////////////////////////////////
extern PFNGLBLENDCOLORPROC                  glBlendColor;
extern PFNGLBLENDEQUATIONPROC               glBlendEquation;
extern PFNGLDRAWRANGEELEMENTSPROC           glDrawRangeElements;
extern PFNGLCOLORTABLEPROC                  glColorTable;
extern PFNGLCOLORTABLEPARAMETERFVPROC       glColorTableParameterfv;
extern PFNGLCOLORTABLEPARAMETERIVPROC       glColorTableParameteriv;
extern PFNGLCOPYCOLORTABLEPROC              glCopyColorTable;
extern PFNGLGETCOLORTABLEPROC               glGetColorTable;
extern PFNGLGETCOLORTABLEPARAMETERFVPROC    glGetColorTableParameterfv;
extern PFNGLGETCOLORTABLEPARAMETERIVPROC    glGetColorTableParameteriv;
extern PFNGLCOLORSUBTABLEPROC               glColorSubTable;
extern PFNGLCOPYCOLORSUBTABLEPROC           glCopyColorSubTable;
extern PFNGLCONVOLUTIONFILTER1DPROC         glConvolutionFilter1D;
extern PFNGLCONVOLUTIONFILTER2DPROC         glConvolutionFilter2D;
extern PFNGLCONVOLUTIONPARAMETERFPROC       glConvolutionParameterf;
extern PFNGLCONVOLUTIONPARAMETERFVPROC      glConvolutionParameterfv;
extern PFNGLCONVOLUTIONPARAMETERIPROC       glConvolutionParameteri;
extern PFNGLCONVOLUTIONPARAMETERIVPROC      glConvolutionParameteriv;
extern PFNGLCOPYCONVOLUTIONFILTER1DPROC     glCopyConvolutionFilter1D;
extern PFNGLCOPYCONVOLUTIONFILTER2DPROC     glCopyConvolutionFilter2D;
extern PFNGLGETCONVOLUTIONFILTERPROC        glGetConvolutionFilter;
extern PFNGLGETCONVOLUTIONPARAMETERFVPROC   glGetConvolutionParameterfv;
extern PFNGLGETCONVOLUTIONPARAMETERIVPROC   glGetConvolutionParameteriv;
extern PFNGLGETSEPARABLEFILTERPROC          glGetSeparableFilter;
extern PFNGLSEPARABLEFILTER2DPROC           glSeparableFilter2D;
extern PFNGLGETHISTOGRAMPROC                glGetHistogram;
extern PFNGLGETHISTOGRAMPARAMETERFVPROC     glGetHistogramParameterfv;
extern PFNGLGETHISTOGRAMPARAMETERIVPROC     glGetHistogramParameteriv;
extern PFNGLGETMINMAXPROC                   glGetMinmax;
extern PFNGLGETMINMAXPARAMETERFVPROC        glGetMinmaxParameterfv;
extern PFNGLGETMINMAXPARAMETERIVPROC        glGetMinmaxParameteriv;
extern PFNGLHISTOGRAMPROC                   glHistogram;
extern PFNGLMINMAXPROC                      glMinmax;
extern PFNGLRESETHISTOGRAMPROC              glResetHistogram;
extern PFNGLRESETMINMAXPROC                 glResetMinmax;
extern PFNGLTEXIMAGE3DPROC                  glTexImage3D;
extern PFNGLTEXSUBIMAGE3DPROC               glTexSubImage3D;
extern PFNGLCOPYTEXSUBIMAGE3DPROC           glCopyTexSubImage3D;


////////////////////////////////////////////////////////////////////////////////
// OpenGL 1.3 functions
////////////////////////////////////////////////////////////////////////////////
extern PFNGLACTIVETEXTUREPROC               glActiveTexture;
extern PFNGLCLIENTACTIVETEXTUREPROC         glClientActiveTexture;
extern PFNGLMULTITEXCOORD1DPROC             glMultiTexCoord1d;
extern PFNGLMULTITEXCOORD1DVPROC            glMultiTexCoord1dv;
extern PFNGLMULTITEXCOORD1FPROC             glMultiTexCoord1f;
extern PFNGLMULTITEXCOORD1FVPROC            glMultiTexCoord1fv;
extern PFNGLMULTITEXCOORD1IPROC             glMultiTexCoord1i;
extern PFNGLMULTITEXCOORD1IVPROC            glMultiTexCoord1iv;
extern PFNGLMULTITEXCOORD1SPROC             glMultiTexCoord1s;
extern PFNGLMULTITEXCOORD1SVPROC            glMultiTexCoord1sv;
extern PFNGLMULTITEXCOORD2DPROC             glMultiTexCoord2d;
extern PFNGLMULTITEXCOORD2DVPROC            glMultiTexCoord2dv;
extern PFNGLMULTITEXCOORD2FPROC             glMultiTexCoord2f;
extern PFNGLMULTITEXCOORD2FVPROC            glMultiTexCoord2fv;
extern PFNGLMULTITEXCOORD2IPROC             glMultiTexCoord2i;
extern PFNGLMULTITEXCOORD2IVPROC            glMultiTexCoord2iv;
extern PFNGLMULTITEXCOORD2SPROC             glMultiTexCoord2s;
extern PFNGLMULTITEXCOORD2SVPROC            glMultiTexCoord2sv;
extern PFNGLMULTITEXCOORD3DPROC             glMultiTexCoord3d;
extern PFNGLMULTITEXCOORD3DVPROC            glMultiTexCoord3dv;
extern PFNGLMULTITEXCOORD3FPROC             glMultiTexCoord3f;
extern PFNGLMULTITEXCOORD3FVPROC            glMultiTexCoord3fv;
extern PFNGLMULTITEXCOORD3IPROC             glMultiTexCoord3i;
extern PFNGLMULTITEXCOORD3IVPROC            glMultiTexCoord3iv;
extern PFNGLMULTITEXCOORD3SPROC             glMultiTexCoord3s;
extern PFNGLMULTITEXCOORD3SVPROC            glMultiTexCoord3sv;
extern PFNGLMULTITEXCOORD4DPROC             glMultiTexCoord4d;
extern PFNGLMULTITEXCOORD4DVPROC            glMultiTexCoord4dv;
extern PFNGLMULTITEXCOORD4FPROC             glMultiTexCoord4f;
extern PFNGLMULTITEXCOORD4FVPROC            glMultiTexCoord4fv;
extern PFNGLMULTITEXCOORD4IPROC             glMultiTexCoord4i;
extern PFNGLMULTITEXCOORD4IVPROC            glMultiTexCoord4iv;
extern PFNGLMULTITEXCOORD4SPROC             glMultiTexCoord4s;
extern PFNGLMULTITEXCOORD4SVPROC            glMultiTexCoord4sv;
extern PFNGLLOADTRANSPOSEMATRIXFPROC        glLoadTransposeMatrixf;
extern PFNGLLOADTRANSPOSEMATRIXDPROC        glLoadTransposeMatrixd;
extern PFNGLMULTTRANSPOSEMATRIXFPROC        glMultTransposeMatrixf;
extern PFNGLMULTTRANSPOSEMATRIXDPROC        glMultTransposeMatrixd;
extern PFNGLSAMPLECOVERAGEPROC              glSampleCoverage;
extern PFNGLCOMPRESSEDTEXIMAGE3DPROC        glCompressedTexImage3D;
extern PFNGLCOMPRESSEDTEXIMAGE2DPROC        glCompressedTexImage2D;
extern PFNGLCOMPRESSEDTEXIMAGE1DPROC        glCompressedTexImage1D;
extern PFNGLCOMPRESSEDTEXSUBIMAGE3DPROC     glCompressedTexSubImage3D;
extern PFNGLCOMPRESSEDTEXSUBIMAGE2DPROC     glCompressedTexSubImage2D;
extern PFNGLCOMPRESSEDTEXSUBIMAGE1DPROC     glCompressedTexSubImage1D;
extern PFNGLGETCOMPRESSEDTEXIMAGEPROC       glGetCompressedTexImage;


////////////////////////////////////////////////////////////////////////////////
// OpenGL ARB functions
////////////////////////////////////////////////////////////////////////////////
//14.   GL_ARB_point_parameters
extern PFNGLPOINTPARAMETERFARBPROC          glPointParameterfARB;
extern PFNGLPOINTPARAMETERFVARBPROC         glPointParameterfvARB;
//15.   GL_ARB_vertex_blend
extern PFNGLWEIGHTBVARBPROC                 glWeightbvARB;
extern PFNGLWEIGHTSVARBPROC                 glWeightsvARB;
extern PFNGLWEIGHTIVARBPROC                 glWeightivARB;
extern PFNGLWEIGHTFVARBPROC                 glWeightfvARB;
extern PFNGLWEIGHTDVARBPROC                 glWeightdvARB;
extern PFNGLWEIGHTUBVARBPROC                glWeightubvARB;
extern PFNGLWEIGHTUSVARBPROC                glWeightusvARB;
extern PFNGLWEIGHTUIVARBPROC                glWeightuivARB;
extern PFNGLWEIGHTPOINTERARBPROC            glWeightPointerARB;
extern PFNGLVERTEXBLENDARBPROC              glVertexBlendARB;
//16.   GL_ARB_matrix_palette
extern PFNGLCURRENTPALETTEMATRIXARBPROC     glCurrentPaletteMatrixARB;
extern PFNGLMATRIXINDEXUBVARBPROC           glMatrixIndexubvARB;
extern PFNGLMATRIXINDEXUSVARBPROC           glMatrixIndexusvARB;
extern PFNGLMATRIXINDEXUIVARBPROC           glMatrixIndexuivARB;
extern PFNGLMATRIXINDEXPOINTERARBPROC       glMatrixIndexPointerARB;
//18.   GL_ARB_texture_env_crossbar
//21.   GL_ARB_texture_mirrored_repeat
//22.   GL_ARB_depth_texture
//23.   GL_ARB_shadow
//24.   GL_ARB_shadow_ambient
//25.   GL_ARB_window_pos
extern PFNGLWINDOWPOS2DARBPROC              glWindowPos2dARB;
extern PFNGLWINDOWPOS2DVARBPROC             glWindowPos2dvARB;
extern PFNGLWINDOWPOS2FARBPROC              glWindowPos2fARB;
extern PFNGLWINDOWPOS2FVARBPROC             glWindowPos2fvARB;
extern PFNGLWINDOWPOS2IARBPROC              glWindowPos2iARB;
extern PFNGLWINDOWPOS2IVARBPROC             glWindowPos2ivARB;
extern PFNGLWINDOWPOS2SARBPROC              glWindowPos2sARB;
extern PFNGLWINDOWPOS2SVARBPROC             glWindowPos2svARB;
extern PFNGLWINDOWPOS3DARBPROC              glWindowPos3dARB;
extern PFNGLWINDOWPOS3DVARBPROC             glWindowPos3dvARB;
extern PFNGLWINDOWPOS3FARBPROC              glWindowPos3fARB;
extern PFNGLWINDOWPOS3FVARBPROC             glWindowPos3fvARB;
extern PFNGLWINDOWPOS3IARBPROC              glWindowPos3iARB;
extern PFNGLWINDOWPOS3IVARBPROC             glWindowPos3ivARB;
extern PFNGLWINDOWPOS3SARBPROC              glWindowPos3sARB;
extern PFNGLWINDOWPOS3SVARBPROC             glWindowPos3svARB;


////////////////////////////////////////////////////////////////////////////////
// OpenGL EXT functions
////////////////////////////////////////////////////////////////////////////////
//97.   GL_EXT_compiled_vertex_array
extern PFNGLLOCKARRAYSEXTPROC               glLockArraysEXT;
extern PFNGLUNLOCKARRAYSEXTPROC             glUnlockArraysEXT;


////////////////////////////////////////////////////////////////////////////////
// OpenGL NV functions
////////////////////////////////////////////////////////////////////////////////
///190. GL_NV_vertex_array_range
extern PFNWGLALLOCATEMEMORYNVPROC           wglAllocateMemoryNV;
extern PFNWGLFREEMEMORYNVPROC               wglFreeMemoryNV;
extern PFNGLFLUSHVERTEXARRAYRANGENVPROC     glFlushVertexArrayRangeNV;
extern PFNGLVERTEXARRAYRANGENVPROC          glVertexArrayRangeNV;
///262. GL_NV_point_sprite
extern PFNGLPOINTPARAMETERINVPROC           glPointParameteriNV;
extern PFNGLPOINTPARAMETERIVNVPROC          glPointParameterivNV;



////////////////////////////////////////////////////////////////////////////////
// OpenGL ATI functions
////////////////////////////////////////////////////////////////////////////////
///247. GL_ATI_vertex_array_object
extern PFNGLNEWOBJECTBUFFERATIPROC          glNewObjectBufferATI;
extern PFNGLISOBJECTBUFFERATIPROC           glIsObjectBufferATI;
extern PFNGLUPDATEOBJECTBUFFERATIPROC       glUpdateObjectBufferATI;
extern PFNGLGETOBJECTBUFFERFVATIPROC        glGetObjectBufferfvATI;
extern PFNGLGETOBJECTBUFFERIVATIPROC        glGetObjectBufferivATI;
extern PFNGLDELETEOBJECTBUFFERATIPROC       glDeleteObjectBufferATI;
extern PFNGLARRAYOBJECTATIPROC              glArrayObjectATI;
extern PFNGLGETARRAYOBJECTFVATIPROC         glGetArrayObjectfvATI;
extern PFNGLGETARRAYOBJECTIVATIPROC         glGetArrayObjectivATI;
extern PFNGLVARIANTARRAYOBJECTATIPROC       glVariantArrayObjectATI;
extern PFNGLGETVARIANTARRAYOBJECTFVATIPROC  glGetVariantArrayObjectfvATI;
extern PFNGLGETVARIANTARRAYOBJECTIVATIPROC  glGetVariantArrayObjectivATI;
