////////////////////////////////////////////////////////////////////////////////
/*! \file       gfx/structs.h
**  \brief      Generic structures used in the graphics engine
**  \author     M Jared Finder
**  \date       2/13/2003 7:05:58 PM
*/
////////////////////////////////////////////////////////////////////////////////
#pragma once


////////////////////////////////////////////////////////////////////////////////
// Forward Declarations and needed includes
////////////////////////////////////////////////////////////////////////////////


namespace gfx {
////////////////////////////////////////////////////////////////////////////////
/*! \struct     Resolution
**  \brief      Holds all data pertaining to a fullscreen resolution
**  \author     M Jared Finder
**  \date       10/15/2002 7:29:48 PM
**  \warning    none
*/
////////////////////////////////////////////////////////////////////////////////
struct Resolution
{
    int width;         //< width in pixels
    int height;        //< height in pixels
    int bpp;           //< bits per pixel
    int frequency;     //< refresh rate.  0 implies an unknown rate
};

    
}