////////////////////////////////////////////////////////////////////////////////
/*!	\file		GUI_CheckBox.cpp
**	\brief		implementation file for GUI_CheckBox.h
**	\author		John Corpening
**	\date		2/22/2003 11:10:11 AM
**	\par		DESCRIPTION:
**	\par		REMARKS:
*/
////////////////////////////////////////////////////////////////////////////////

#include "GUI_Includes.h"
using namespace UserInput;

// memory leak detection
#ifdef _DEBUG
    #include"memleak.h"
    #define new DEBUG_NEW
    #undef THIS_FILE
    static char THIS_FILE[] = __FILE__;
#endif

////////////////////////////////////////////////////////////////////////////////
//	FUNCTION:	UI_CheckBox::specificLogic
/*!	\brief		determines whether or not the check box has been clicked
**				and sets the update flag accordingly
**	\return		true if clicked
**	\exception	none
**	\author		John Corpening
**	\date		2/22/2003 11:10:58 AM
**	\warning	none
*/
////////////////////////////////////////////////////////////////////////////////
bool UI_CheckBox::specificLogic()
{
	updated = false;
	if((cursor->X() >= x) 
		&& (cursor->X() < (x + width))
		&& (cursor->Y() >= y)
		&& (cursor->Y() < (y + height))
		&& (cursor->isLTriggered() || cursor->isRTriggered() || cursor->isWTriggered()))
	{
		clicked = !clicked;
		updated = true;
		AcqariusSound::UIClient::Instance()->Beep();
		return true;
	}
	return false;
}

////////////////////////////////////////////////////////////////////////////////
//	FUNCTION:	UI_CheckBox::draw
/*!	\brief		draws the checkbox
**	\return		none
**	\exception	none
**	\author		John Corpening
**	\date		2/22/2003 11:11:04 AM
**	\warning	none
*/
////////////////////////////////////////////////////////////////////////////////
void UI_CheckBox::draw()
{
	style->drawItemBackground(x, y, width, height, mouseOver);
	style->drawText(x+width*0.25f,y+height*0.4f, caption.c_str());

	style->drawCheckBoxBackground(x + 0.02f*width, y + 0.1f*height,width*0.1f, height*0.8f, clicked);
	
	style->draw();
}