////////////////////////////////////////////////////////////////////////////////
/*!	\file		GUI_CheckBox.h
**	\brief		GUI checkbox primitive
**	\author		John Corpening
**	\date		2/22/2003 11:08:30 AM
**	\par		DESCRIPTION:
**	\par		REMARKS:
*/
////////////////////////////////////////////////////////////////////////////////

#pragma once

namespace UserInput
{
////////////////////////////////////////////////////////////////////////////////
/*!	\class		UI_CheckBox
**	\brief		checkbox class
**	\author		John Corpening
**	\date		2/22/2003 11:09:23 AM
**	\warning	none
*/
////////////////////////////////////////////////////////////////////////////////
class UI_CheckBox : public UI_Pushbutton
{
	bool updated;
public:
	UI_CheckBox() : updated(false){}
	UI_CheckBox(UI_Screen* Screen) : UI_Pushbutton(Screen), updated(false){}

	bool isUpdated(){return updated;}
	void setCheckState(bool state) { clicked = state;}
	void draw();

	////////////////////////////////////////////////////////////////////////////////
	//	FUNCTION:	UI_CheckBox::specificLogic
	/*!	\brief		determines whether or not the check box has been clicked
	**				and sets the update flag accordingly
	**	\return		true if clicked
	**	\exception	none
	**	\author		John Corpening
	**	\date		2/22/2003 11:10:58 AM
	**	\warning	none
	*/
	////////////////////////////////////////////////////////////////////////////////
	bool specificLogic();
	
};
};