#pragma warning(disable:4786)

#include "GUI_Includes.h"

// memory leak detection
#ifdef _DEBUG
    #include"memleak.h"
    #define new DEBUG_NEW
    #undef THIS_FILE
    static char THIS_FILE[] = __FILE__;
#endif
using namespace UserInput;
gfx::Texture*	UI_Style::mtex = 0;
gfx::Texture*	UI_Style::itex = 0;
gfx::Texture*	UI_Style::ctex = 0;
gfx::Font*		UI_Style::font = 0;
gfx::Texture*	UI_Style::titleTex = 0;
gfx::Texture*	UI_Style::ULTex = 0;
gfx::Texture*	UI_Style::URTex = 0;
gfx::Texture*	UI_Style::LLTex = 0;
gfx::Texture*	UI_Style::LRTex = 0;
gfx::Texture*	UI_Style::textbgTex = 0;
gfx::Texture*	UI_Style::editbgTex = 0;
gfx::Texture*	UI_Style::sIndexTex = 0;
gfx::Texture*	UI_Style::cursorTex = 0;
gfx::Texture*	UI_Style::cutex = 0;

void UI_Style::staticMemberInit()
{
	if(!mtex && !itex && !ctex && !font && !titleTex && !ULTex && !URTex && !LLTex && !LRTex)
	{
		mtex		= new gfx::Texture("Resources/defaultStyle/backdrop.tga");
		ctex		= new gfx::Texture("Resources/defaultStyle/checkBox_checked.tga");
		cutex		= new gfx::Texture("Resources/defaultStyle/checkBox_unchecked.tga");
		itex		= new gfx::Texture("Resources/defaultStyle/button_up.tga");
		textbgTex	= new gfx::Texture("Resources/defaultStyle/textboxbackground.tga");
		editbgTex	= new gfx::Texture("Resources/defaultStyle/editboxbackground.tga");
		sIndexTex	= new gfx::Texture("Resources/defaultStyle/sliderIndex.tga");
		cursorTex	= new gfx::Texture("Resources/defaultStyle/cursor_blue.tga",true);

		titleTex = new gfx::Texture("Resources/Fullscreens/Thalassic Logo.tga");

		ULTex = new gfx::Texture("Resources/Credits/Credits_(0,0).tga", true);
		URTex = new gfx::Texture("Resources/Credits/Credits_(1,0).tga", true);
		LLTex = new gfx::Texture("Resources/Credits/Credits_(0,1).tga", true);
		LRTex = new gfx::Texture("Resources/Credits/Credits_(1,1).tga", true);


		font = new gfx::Font("Resources/Font/Font.tga");
		
	}
}

UI_Style::~UI_Style()
{
		if(mtex) delete mtex;
		if(ctex) delete ctex;
		if(cutex) delete cutex;
		if(itex) delete itex;
		if(textbgTex) delete textbgTex;
		if(editbgTex) delete editbgTex;
		if(sIndexTex) delete sIndexTex;
		if(cursorTex) delete cursorTex;

		if(titleTex) delete titleTex;

		if(ULTex) delete ULTex;
		if(URTex) delete URTex;
		if(LLTex) delete LLTex;
		if(LRTex) delete LRTex;

		if(font) delete font;

		mtex = 0;
		ctex = 0;
		cutex = 0;
		itex = 0;
		textbgTex = 0;
		editbgTex = 0;
		sIndexTex = 0;
		cursorTex = 0;

		titleTex = 0;

		ULTex = 0;
		URTex = 0;
		LLTex = 0;
		LRTex = 0;

		font = 0;
		
}

// changed by nate [2/12/2003]
UI_Style::UI_Style() : bg_Width(0.1f), bg_Height(0.1f), mSprite(*mtex, bg_Width, bg_Height), Draw(false),
iSprite(*itex, bg_Width, bg_Height), cSprite(*ctex, bg_Width, bg_Height),
titleSprite(*titleTex, 1, 1), ULSprite(*ULTex, 1,1),URSprite(*URTex, 1,1),LLSprite(*LLTex, 1,1),LRSprite(*LRTex, 1,1),
textbgSprite(*textbgTex, bg_Width, bg_Height), editbgSprite(*editbgTex, bg_Width, bg_Height),
sIndexSprite(*sIndexTex, bg_Width, bg_Height), cursorSprite(*cursorTex, bg_Width, bg_Height),
cuSprite(*cutex, bg_Width, bg_Height)
{
	mbg_Draw = false;
	ibg_Draw = false;
	tx_Draw = false;
	cbg_Draw = false;
	title_Draw = false;
	credits_Draw = false;
	textbg_Draw = false;
	editbg_Draw = false;
	sIndex_Draw = false;
	cursor_Draw = false;
	ibg_mouseOver = false;
}

void UI_Style::drawItemBackground(float x, float y, float width, float height, bool val)
{
	ibg_x = x;
	ibg_y = y;
	ibg_xScale = width / bg_Width;
	ibg_yScale = height / bg_Height;
	ibg_Draw = true;
	Draw = true;
	ibg_mouseOver = val;
}

void UI_Style::drawTextBackground(float x, float y, float width, float height)
{
	textbg_x = x;
	textbg_y = y;
	textbg_xScale = width / bg_Width;
	textbg_yScale = height / bg_Height;
	textbg_Draw = true;
	Draw = true;
}

void UI_Style::drawEditBackground(float x, float y, float width, float height, bool val)
{
	editbg_x = x;
	editbg_y = y;
	editbg_xScale = width / bg_Width;
	editbg_yScale = height / bg_Height;
	editbg_Draw = true;
	editbg_mouseOver = val;
	Draw = true;
}

void UI_Style::drawSliderIndex(float x, float y, float width, float height)
{
	sIndex_x = x;
	sIndex_y = y;
	sIndex_xScale = width / bg_Width;
	sIndex_yScale = height / bg_Height;
	sIndex_Draw = true;
	Draw = true;
}

void UI_Style::drawCursor(float x, float y, float width, float height)
{
	cursor_x = x;
	cursor_y = y;
	cursor_xScale = width / bg_Width;
	cursor_yScale = height / bg_Height;
	cursor_Draw = true;
	Draw = true;
}

void UI_Style::drawMenuBackground(float x, float y, float width, float height)
{
	mbg_x = x;
	mbg_y = y;
	mbg_xScale = width / bg_Width;
	mbg_yScale = height / bg_Height;
	mbg_Draw = true;
	Draw = true;
}

void UI_Style::drawCheckBoxBackground(float x, float y, float width, float height, bool checked)
{
	cbg_x = x;
	cbg_y = y;
	cbg_xScale = width / bg_Width;
	cbg_yScale = height / bg_Height;
	cbg_Draw = true;
	cbg_checked = checked;
	Draw = true;
}

void UI_Style::drawTitle(float x, float y)
{
	title_x = x;
	title_y = y;
	title_Draw = true;
	Draw = true;
}

void UI_Style::drawCredits()
{
	credits_Draw = true;
	Draw = true;
}

void UI_Style::drawText(float x, float y, const char *Text, float width, float height)
{
	UI_Text	temp;
	temp.x = x;
	temp.y = y;
	temp.height = height;
	temp.width = width;
	temp.text = new char[strlen(Text)+1];
	strcpy(temp.text, Text);
	text.push_back(temp);
	tx_Draw = true;
	Draw = true;
}

void UI_Style::Render()
{
	if(title_Draw)
	{
		titleSprite.Draw(title_x, title_y, 0);
		title_Draw = false;
	}

	if(credits_Draw)
	{
		credits_Draw = false;
		ULSprite.Draw(0.0f,		0.144f,		0,	0.64f,	0.856f);
		URSprite.Draw(0.64f,	0.144f,		0,	0.64f,	0.856f);
		LLSprite.Draw(0.0f,		-0.07f,		0,	0.64f,	0.214f);
		LRSprite.Draw(0.64f,	-0.07f,		0,	0.64f,	0.214f);
	}

	if(mbg_Draw)
	{
		mbg_Draw = false;
		mSprite.Draw(mbg_x, mbg_y, 0, mbg_xScale, mbg_yScale);
	}
	if(ibg_Draw)
	{
		ibg_Draw = false;
		if(ibg_mouseOver)
		{
			iSprite.Draw(ibg_x, ibg_y, 0, ibg_xScale, ibg_yScale, 1,0,0);
		}
		else
		{
			iSprite.Draw(ibg_x, ibg_y, 0, ibg_xScale, ibg_yScale);
		}
	}
	if(textbg_Draw)
	{
		textbg_Draw = false;
		textbgSprite.Draw(textbg_x, textbg_y, 0, textbg_xScale, textbg_yScale);
	}
	if(editbg_Draw)
	{
		editbg_Draw = false;
		if(editbg_mouseOver)
		{
				editbgSprite.Draw(editbg_x, editbg_y, 0, editbg_xScale, editbg_yScale, 1, 0, 0);
		}
		else
		{
			editbgSprite.Draw(editbg_x, editbg_y, 0, editbg_xScale, editbg_yScale);
		}
	}
	if(sIndex_Draw)
	{
		sIndex_Draw = false;
		sIndexSprite.Draw(sIndex_x, sIndex_y, 0, sIndex_xScale, sIndex_yScale);
	}

	if(cbg_Draw)
	{
		cbg_Draw = false;
		if(cbg_checked) 
			cSprite.Draw(cbg_x, cbg_y, 0, cbg_xScale, cbg_yScale);
		else
			cuSprite.Draw(cbg_x, cbg_y, 0, cbg_xScale, cbg_yScale);
	}

	if(tx_Draw)
	{
		tx_Draw = false;
		int size = text.size();
		for(int i = 0; i < size; i++)
		{
			// changed by nate [2/11/2003]
//			font.Write(text[i].x, text[i].y, 1.0f, 0.0f, 0.0f, text[i].text);
			font->Write(text[i].width, text[i].height, text[i].x, text[i].y, 1.0f, 0.0f, 0.0f, text[i].text);
			delete[] text[i].text;
		}
		text.clear();
	}
	if(cursor_Draw)
	{
		cursor_Draw = false;
		cursorSprite.Draw(cursor_x, cursor_y, 0, cursor_xScale, cursor_yScale);
	}
}
void UI_Style::draw()
{
	if(Draw)
	{
		// Changed by nate [2/12/2003]
		IRenderable2DAlpha::SetRender();	
		Draw = false;
	}
}