////////////////////////////////////////////////////////////////////////////////
/*!	\file		GUI_Style.h
**	\brief		classes for specifying how things will be drawn
**	\author		John Corpening
**	\date		11/25/2002 6:10:58 PM
**	\par		DESCRIPTION:
**	\par		REMARKS:
**				Everything you see here will change as soon as I can get to it.
*/
////////////////////////////////////////////////////////////////////////////////


#pragma once

namespace UserInput
{

struct UI_Text
{
	float	x;
	float	y;
	float	height;
	float	width;
	char*	text;
};

// Changed by nate. [2/12/2003]
class UI_Style : public gfx::IRenderable2DAlpha
{
	float			bg_Width;
	float			bg_Height;

	bool			ibg_Draw;		//!< draw the item background flag
	bool			ibg_mouseOver;
	float			ibg_x;
	float			ibg_y;
	float			ibg_xScale;
	float			ibg_yScale;
static gfx::Texture	*itex;
	gfx::Sprite		iSprite;

	bool			mbg_Draw;		//!< draw the menu background flag
	float			mbg_x;
	float			mbg_y;
	float			mbg_xScale;
	float			mbg_yScale;
static gfx::Texture	*mtex;			//!< Cursor Texture
    gfx::Sprite		mSprite;		//!< Cursor Sprite

	bool			cbg_Draw;		//!< draw the checkbox background flag
	bool			cbg_checked;
	float			cbg_x;
	float			cbg_y;
	float			cbg_xScale;
	float			cbg_yScale;
static gfx::Texture	*ctex;
static gfx::Texture *cutex;
	gfx::Sprite		cSprite;
	gfx::Sprite		cuSprite;

	bool			title_Draw;		//!< draw Title flag
	float			title_x;
	float			title_y;
static gfx::Texture	*titleTex;
	gfx::Sprite		titleSprite;

	bool			credits_Draw;	//!< Credits
//	float			title_x;
//	float			title_y;
static gfx::Texture *ULTex;
static gfx::Texture *URTex;
static gfx::Texture *LLTex;
static gfx::Texture *LRTex;
	gfx::Sprite		ULSprite;
	gfx::Sprite		URSprite;
	gfx::Sprite		LLSprite;
	gfx::Sprite		LRSprite;

	bool			textbg_Draw;		//!< draw the text background flag
	float			textbg_x;
	float			textbg_y;
	float			textbg_xScale;
	float			textbg_yScale;
static gfx::Texture	*textbgTex;
	gfx::Sprite		textbgSprite;

	bool			editbg_Draw;		//!< draw the edit background flag
	bool			editbg_mouseOver;
	float			editbg_x;
	float			editbg_y;
	float			editbg_xScale;
	float			editbg_yScale;
static gfx::Texture	*editbgTex;
	gfx::Sprite		editbgSprite;

	bool			sIndex_Draw;		//!< draw the slider Index background flag
//	bool			sIndex_checked;
	float			sIndex_x;
	float			sIndex_y;
	float			sIndex_xScale;
	float			sIndex_yScale;
static gfx::Texture	*sIndexTex;
	gfx::Sprite		sIndexSprite;

	bool			cursor_Draw;		//!< draw the slider Index background flag
	float			cursor_x;
	float			cursor_y;
	float			cursor_xScale;
	float			cursor_yScale;
static gfx::Texture	*cursorTex;
	gfx::Sprite		cursorSprite;



	bool			tx_Draw;
	std::vector< UI_Text> text;
	static gfx::Font	*font;

	bool			Draw;
	
	void Render();
	
public:

	UI_Style();
	~UI_Style();
	static void staticMemberInit();
	void drawItemBackground(float x, float y, float width, float height, bool val = false);
	void drawMenuBackground(float x, float y, float width, float height);
	void drawTextBackground(float x, float y, float width, float height);
	void drawEditBackground(float x, float y, float width, float height, bool val = false);
	void drawSliderIndex(float x, float y, float width, float height);
	void drawCursor(float x, float y, float width, float height);
	void drawCheckBoxBackground(float x, float y, float width, float height, bool checked);
	void drawText(float x, float y, const char *Text, float width=0.025f, float height=0.025f);
	void drawTitle(float x, float y);
	void drawCredits();
	void draw();
};
}