////////////////////////////////////////////////////////////////////////////////
/*!	\file		GUI_TextBox.cpp
**	\brief		Implementation file for GUI_TextBox.h
**	\author		John Corpening
**	\date		10/30/2002 8:20:57 PM
*/
////////////////////////////////////////////////////////////////////////////////
#pragma warning(disable:4786)

#include "GUI_Includes.h"

// memory leak detection
#ifdef _DEBUG
    #include"memleak.h"
    #define new DEBUG_NEW
    #undef THIS_FILE
    static char THIS_FILE[] = __FILE__;
#endif
using namespace UserInput;
////////////////////////////////////////////////////////////////////////////////
//	FUNCTION:	UI_TextBox::setText
/*!	\brief		sets the text box text
**	\param		Text the text to set
**	\return		none
**	\exception	none
**	\author		John Corpening
**	\date		10/30/2002 8:19:50 PM
**	\warning	none
*/
////////////////////////////////////////////////////////////////////////////////
void UI_TextBox::setText(const char *Text)
{
	if(!Text)
	{
		return;
	}
	text = Text;
}

////////////////////////////////////////////////////////////////////////////////
//	FUNCTION:	UI_TextBox::draw
/*!	\brief		draws the text box
**	\return		none
**	\exception	none
**	\author		John Corpening
**	\date		11/25/2002 6:13:46 PM
**	\warning	none
*/
////////////////////////////////////////////////////////////////////////////////
void UI_TextBox::draw()
{
	style->drawTextBackground(x, y, width, height);
	
	style->drawText(x+width*0.01f,y + height*0.4f, text.c_str());

	style->draw();
}