////////////////////////////////////////////////////////////////////////////////
/*!	\file		GUI_Textbox.h
**	\brief		textbox and ToolTip
**	\author		John Corpening
**	\date		10/30/2002 8:16:51 PM
**	\par		DESCRIPTION:
**	\par		REMARKS:
*/
////////////////////////////////////////////////////////////////////////////////
#pragma once


namespace UserInput
{
////////////////////////////////////////////////////////////////////////////////
/*!	\class		UI_TextBox
**	\brief		plain vanilla text box
**	\author		John Corpening
**	\date		10/30/2002 8:17:30 PM
**	\warning	none
*/
////////////////////////////////////////////////////////////////////////////////
class UI_TextBox : public UI_MenuItem
{
public:
	////////////////////////////////////////////////////////////////////////////////
	//	FUNCTION:	UI_TextBox::UI_TextBox
	/*!	\brief		Constructor
	**	\param		screen a pointer to the screen this belongs to
	**	\return		none
	**	\exception	none
	**	\author		John Corpening
	**	\date		10/30/2002 8:18:28 PM
	**	\warning	none
	*/
	////////////////////////////////////////////////////////////////////////////////
	UI_TextBox(UI_Screen* screen) : UI_MenuItem(screen)
	{
		width = 0.2f;
		height = 0.2f;
	}

	UI_TextBox()
	{
		width = 0.2f;
		height = 0.2f;
	}

	////////////////////////////////////////////////////////////////////////////////
	//	FUNCTION:	UI_TextBox::setText
	/*!	\brief		sets the text box text
	**	\param		Text the text to set
	**	\return		none
	**	\exception	none
	**	\author		John Corpening
	**	\date		10/30/2002 8:19:50 PM
	**	\warning	none
	*/
	////////////////////////////////////////////////////////////////////////////////
	void setText(const char* Text);

		////////////////////////////////////////////////////////////////////////////////
	//	FUNCTION:	UI_EditBox::getText
	/*!	\brief		returns the text currently in the edit box
	**	\return		none
	**	\exception	none
	**	\author		John Corpening
	**	\date		11/25/2002 3:17:36 PM
	**	\warning	none
	*/
	////////////////////////////////////////////////////////////////////////////////
	const char* getText() {return text.c_str();}

	////////////////////////////////////////////////////////////////////////////////
	//	FUNCTION:	UI_TextBox::draw
	/*!	\brief		draws the text box
	**	\return		none
	**	\exception	none
	**	\author		John Corpening
	**	\date		11/25/2002 6:13:46 PM
	**	\warning	none
	*/
	////////////////////////////////////////////////////////////////////////////////
	virtual void draw();

protected:
	////////////////////////////////////////////////////////////////////////////////
	//	FUNCTION:	UI_TextBox::specificLogic
	/*!	\brief		basic text boxes always returns false
	**	\return		none
	**	\exception	none
	**	\author		John Corpening
	**	\date		10/30/2002 8:25:00 PM
	**	\warning	none
	*/
	////////////////////////////////////////////////////////////////////////////////
	virtual bool specificLogic(){return false;}

	std::string text;	//!< The Text to display
};

////////////////////////////////////////////////////////////////////////////////
/*!	\class		UI_ToolTip 
**	\brief		Same as a text box but will draw differently
**	\author		John Corpening
**	\date		11/25/2002 6:14:28 PM
**	\warning	none
*/
////////////////////////////////////////////////////////////////////////////////
class UI_ToolTip : public UI_TextBox
{
public:
	UI_ToolTip(UI_Screen* Screen) : UI_TextBox(Screen) {}
	UI_ToolTip(){}
};

}