#include "StrObj.hpp"
using namespace InterpretationModule;
// memory leak detection
#ifdef _DEBUG
    #include"memleak.h"
    #define new DEBUG_NEW
    #undef THIS_FILE
    static char THIS_FILE[] = __FILE__;
#endif


//See header for documentation.
void StrObj::GetMouth_Action	(String_type** str) throw()
{
	if(str)
		*str = &m_mouthAct;
}


//See header for documentation.
void StrObj::GetMouth_Target	(String_type** str) throw()
{
	if(str)
		*str = &m_mouthTarg;
}


//See header for documentation.
void StrObj::GetMarker_Action	(String_type** str) throw()
{
	if(str)
		*str = &m_markerAct;
}



//See header for documentation.
void StrObj::GetMarker_Target	(String_type** str) throw()
{
	if(str)
		*str = &m_markerTarg;
}



//See header for documentation.
void StrObj::GetMove_Action		(String_type** str) throw()
{
	if(str)
		*str = &m_moveAct;
}



//See header for documentation.
void StrObj::GetMove_Target		(String_type** str) throw()
{
	if(str)
		*str = &m_moveTarg;
}



//See header for documentation.
void StrObj::SetMouth_Action	(const char* str) throw()
{
	m_mouthAct.assign(str, strlen(str));
}


//See header for documentation.
void StrObj::SetMouth_Target	(const char* str) throw()
{
	m_mouthTarg.assign(str, strlen(str));
}


//See header for documentation.
void StrObj::SetMarker_Action	(const char* str) throw()
{
	m_markerAct.assign(str, strlen(str));
}


//See header for documentation.
void StrObj::SetMarker_Target	(const char* str) throw()
{
	m_markerTarg.assign(str, strlen(str));
}


//See header for documentation.
void StrObj::SetMove_Action		(const char* str) throw()
{
	m_moveAct.assign(str, strlen(str));
}


//See header for documentation.
void StrObj::SetMove_Target		(const char* str) throw()
{
	m_moveTarg.assign(str, strlen(str));
}


void StrObj::ClearStrings(void) throw()
{
	const char*		none	 = "None";
	const char*		na		 = "N/A";
	const size_t	noneSize = strlen(none);
	const size_t	naSize	 = strlen(na);

	m_mouthAct.assign(none,noneSize);
	m_mouthTarg.assign(na,naSize);
	m_markerAct.assign(none,noneSize);
	m_markerTarg.assign(na,naSize);
	m_moveAct.assign(none,noneSize);	
	m_moveTarg.assign(na,naSize);	
}