#pragma once
#include <string>

namespace InterpretationModule
{

	class Action;

	////////////////////////////////////////////////////////////////////////////////
	/*!	\class		
	**	\brief		
	**	\author		Nate Cleveland
	**	\date		3/17/2003 1:00:56 PM
	**	\warning	none
	*/
	////////////////////////////////////////////////////////////////////////////////
	class StrObj
	{
	public:

		//! String type used by object
		typedef std::string String_type;

		//set string methods
		void GetMouth_Action	(String_type** str) throw();
		void GetMouth_Target	(String_type** str) throw();
		void GetMarker_Action	(String_type** str) throw();
		void GetMarker_Target	(String_type** str) throw();
		void GetMove_Action		(String_type** str) throw();
		void GetMove_Target		(String_type** str) throw();
		
		//set string methods
		void SetMouth_Action	(const char* str) throw();
		void SetMouth_Target	(const char* str) throw();
		void SetMarker_Action	(const char* str) throw();
		void SetMarker_Target	(const char* str) throw();
		void SetMove_Action		(const char* str) throw();
		void SetMove_Target		(const char* str) throw();
		

		//Clear out all the strings.
		void ClearStrings(void)throw();

	private:
		
		String_type		m_mouthAct;		//!< string holding the mouth action
		String_type		m_mouthTarg;	//!< string holding the mouth target
		String_type		m_markerAct;	//!< string holding the marker action
		String_type		m_markerTarg;	//!< string holding the marker target
		String_type		m_moveAct;		//!< string holding the movement action
		String_type		m_moveTarg;		//!< string holding the movement target
	};
}