#pragma once
#include <vector>

namespace InterpretationModule
{	

	typedef float Attribute_type;						//!< Data type of all Attributes
	extern const Attribute_type MAX_ATTRIBUTE_VALUE;	//!< Max size of any attribute
	extern const Attribute_type MIN_ATTRIBUTE_VALUE;	//!< Min size of any attribute

	//!returns the Normalized Value of the passed in value.
	Attribute_type NormalizeAttributeValue(Attribute_type at);

	//!generates an attribute table based on the passed in values.
	void GenerateAttributeTable(Attribute_type primarySeed, Attribute_type secondarySeed, 
								Attribute_type minVal, Attribute_type maxVal,
								std::vector<Attribute_type>& attribTable, int& levels);

	//!finds an entry in the table.
	Attribute_type FindTableEntry(Attribute_type inputValue,  
							std::vector<Attribute_type> attribTable, int levels);

}//end namespace InterpretationModule