#include "physicData.hpp"
#include <math.h>
using namespace InterpretationModule;
// memory leak detection
#ifdef _DEBUG
    #include"memleak.h"
    #define new DEBUG_NEW
    #undef THIS_FILE
    static char THIS_FILE[] = __FILE__;
#endif

//See header for documentation.
PhysicData::PhysicData(float x/*=0*/,float y/*=0*/, float z/*=0*/, const Voxel_type& voxel/*=0*/)
:m_x(x), m_y(y), m_z(z), m_prevVoxel(voxel), m_currDist(0)
{

}

//See header for documentation.
void PhysicData::Update(float elapsedTime, float x, float y, float z, const Voxel_type& currVoxel)
{
	////1. update the voxel checking logic
	m_isNewVoxel = this->m_prevVoxel == currVoxel;
	this->m_prevVoxel = currVoxel;

	////2. update the distance stuff.
	this->m_currDist = (m_x - x)*(m_x - x) + (m_z - z)*(m_z - z) + (m_z - z)*(m_z - z);
	this->m_currDist = static_cast<float>(sqrt(this->m_currDist));

	////3. update the position stuff
	m_x = x;
	m_y = y;
	m_z = z;
	return ;
}
using namespace std;
//See header for documentation
ostream& InterpretationModule::operator << (ostream &outStream, const PhysicData& phyData)
{
	char buffer[512] = {0};

	sprintf(buffer,"Position (%f, %f, %f)\n",phyData.GetXPos(),phyData.GetYPos(),phyData.GetZPos());
	outStream << buffer;

	return outStream;
}

//See header for documentation
istream& InterpretationModule::operator>> (istream& inStream, PhysicData& phyData)
{
	char buffer[512] = {0};

	inStream.getline(buffer, 512, '\n');
	sscanf(buffer, "Position (%f, %f, %f)\n", &phyData.m_x, &phyData.m_y, &phyData.m_z);

	return inStream;
}

