////////////////////////////////////////////////////////////////////////////////
/*!	\file		
**	\brief		
**	\author		Nate Cleveland
**	\date		2/21/2003 9:14:51 AM
**	\par		DESCRIPTION:
**					
**	\par		REMARKS:
**					
*/
////////////////////////////////////////////////////////////////////////////////
#include "fishBodyUtils.hpp"


///Forward Declarations.
class TankSimulatorClient;

namespace InterpretationModule
{

	////////////////////////////////////////////////////////////////////////////////
	/*!	\class		
	**	\brief		
	**	\author		Nate Cleveland
	**	\date		2/21/2003 9:15:03 AM
	**	\warning	none
	*/
	////////////////////////////////////////////////////////////////////////////////
	class WorldBoundryTracer
	{
		TankSimulatorClient*		m_tankClient;	//!< Pntr to the tank client.


	public:

		////////////////////////////////////////////////////////////////////////////////
		//	FUNCTION:	
		/*!	\brief		
		**	\param		
		**	\return		none
		**	\exception	none
		**	\par		DESCRIPTION:
		**					
		**	\author		Nate Cleveland
		**	\date		2/21/2003 9:16:26 AM
		**	\warning	none
		*/
		////////////////////////////////////////////////////////////////////////////////
		WorldBoundryTracer(TankSimulatorClient* pTankClient);

		////////////////////////////////////////////////////////////////////////////////
		//	FUNCTION:	
		/*!	\brief		Returns to the caller the distance to the world collision. Ignores
		**				 the height map.
		**
		**	\param		vx			x-componet of vector to trace with
		**	\param		vy			y-componet of vector to trace with
		**	\param		vz			z-componet of vector to trace with
		**	\param		startPnt	pnt to start tracing from.
		**
		**	\return		Distance to edge of simulation, -1 if none. 
		**	\exception	none				
		**	\author		Nate Cleveland
		**	\date		2/21/2003 9:18:22 AM
		**	\warning	none
		*/
		////////////////////////////////////////////////////////////////////////////////
		float operator () (InterpPnt_type& startPnt, float vx, float vy, float vz);

	};
}