////////////////////////////////////////////////////////////////////////////////
/*! \file       linear_alg.h
**  \brief      Basic linear algebra functionality
**  \author     M Jared Finder
**  \date       10/4/2002 1:53:32 PM
**  \par        DESCRIPTION:
**                  The functionality currently provided consists of optimized
**                  2d, 3d, and 4d vectors and matrices.  Arbitrarily sized
**                  vectors and matrices are not provided.
**  \par        REMARKS:
**                  Currently, the math library includes all standard libraries
**                  it requires on its own.  There shouldn't be much work to
**                  changing this to using precompiled-headers.
**
**                  Requires math.h to be included.
*/
////////////////////////////////////////////////////////////////////////////////
#pragma once


// Linear Algebra functionality
#include "./vector2.h"
#include "./vector3.h"
#include "./vector4.h"

#include "./matrix2.h"
#include "./matrix3.h"
#include "./matrix4.h"
