////////////////////////////////////////////////////////////////////////////////
/*!	\file		WinSockSynthesis.h
**	\brief		"Synthesizes" the Winsock 2.2 datatypes so as to avoid #including <winsock2.h> more
				than once
**	\author		Nathan Frost
**	\date		1/23/2003 9:35:10 AM
**	\par		DESCRIPTION:
**					
**	\par		REMARKS:
					- Copied and pasted straight from the <winsock2.h> header file
**					
*/
////////////////////////////////////////////////////////////////////////////////

#pragma once


/*
 * Basic system type definitions, taken from the BSD file sys/types.h.
 */
typedef unsigned char   u_char;
typedef unsigned short  u_short;
typedef unsigned int    u_int;
typedef unsigned long   u_long;

/*
 * The new type to be used in all
 * instances which refer to sockets.
 */
typedef u_int           SOCKET;

struct fd_set;

