////////////////////////////////////////////////////////////////////////////////
/*!	\file		ActiveSound_FMOD.cpp
**	\brief		Defines all the methods presented in the ActiveSound_FMOD.h.
**	\author		Nate Cleveland
**	\date		10/14/2002 12:41:46 PM
**	\par		DESCRIPTION: see header for documentation.				
*/
////////////////////////////////////////////////////////////////////////////////
#include "ActiveSound_Fmod.h"
#include "Fmod.h"
using namespace AcqariusSound;
// memory leak detection
#ifdef _DEBUG
    #include"memleak.h"
    #define new DEBUG_NEW
    #undef THIS_FILE
    static char THIS_FILE[] = __FILE__;
#endif

//!See documentation in header
ActiveSound_Fmod::ActiveSound_Fmod(int channel, HSound &h)
:m_channel(channel), m_hSound(h), m_isThreeD(false)
{
	//all work done in the init list.
}//end ActiveSound_Fmod::ActiveSound_Fmod

//!See documentation in header
ActiveSound_Fmod::~ActiveSound_Fmod()
{
	//nothing needed
}//end ActiveSound_Fmod::~ActiveSound_Fmod


//!See documentation in header
bool ActiveSound_Fmod::IsDone(void)
{
	//check to see if the sound is done.
	if(this->m_channel && !FSOUND_IsPlaying(m_channel))
	{
		m_hSound = 0;
		return true;
	}//end if
	return false;
}//end ActiveSound_Fmod::IsDone