////////////////////////////////////////////////////////////////////////////////
/*!	\file		HSound.h
**	\brief		Defines the HSound data type.
**	\author		Nate Cleveland
**	\date		10/14/2002 12:30:31 PM
**	\par		DESCRIPTION: The HSound data type is the handle given to users by
**				 the sound class when they load a sound file. This handle will be
**				 a clients only reference to their loaded sound and will be given 
**				 back to the sound class when the user plays/mutes/frees a sound.
**					
**	\par		REMARKS: Exists within the AcqariusSound namespace.
**					
*/
////////////////////////////////////////////////////////////////////////////////

#pragma once

namespace AcqariusSound
{
	typedef int HSound;			//!< Handle to a sound file loaded by the Sound class.
}
