////////////////////////////////////////////////////////////////////////////////
/*!	\file		LoadedSound_FMOD.cpp
**	\brief		Defines all the methods presented in the LoadedSound_FMOD.h.
**	\author		Nate Cleveland
**	\date		10/14/2002 12:41:46 PM
**	\par		DESCRIPTION: see header for documentation.				
*/
////////////////////////////////////////////////////////////////////////////////
#include "Sound_FMOD.h"
using namespace AcqariusSound;
// memory leak detection
#ifdef _DEBUG
    #include"memleak.h"
    #define new DEBUG_NEW
    #undef THIS_FILE
    static char THIS_FILE[] = __FILE__;
#endif

//!See documentation in header
LoadedSound_Fmod::~LoadedSound_Fmod()
{
	//de-allocate the sound. needs to be done differently depending on which type
	//of this is. Always check for nulls.
	if(!this->m_isStreamed && this->m_handle.m_sample)
		FSOUND_Sample_Free(const_cast<FSOUND_SAMPLE*>(this->m_handle.m_sample));

	else if( this->m_handle.m_stream)
		FSOUND_Stream_Close(this->m_handle.m_stream);
}

//!See documentation in header
LoadedSound_Fmod::LoadedSound_Fmod(FSOUND_SAMPLE *handle, HSound &h, const char *pathName, char vol/* = 127*/)
:m_hSound(h), m_isStreamed(false), m_currVolume(vol)
{
	if((NULL == handle) || (NULL == strcpy(m_pathName, pathName)))
		throw 0;

	this->m_handle.m_sample = handle;
}

//!See documentation in header
LoadedSound_Fmod::LoadedSound_Fmod(FSOUND_STREAM *handle, HSound &h, const char *pathName, char vol/* = 127*/)
:m_hSound(h), m_isStreamed(true), m_currVolume(vol)
{
	if((NULL == handle) || (NULL == strcpy(m_pathName, pathName)))
		throw 0;

	this->m_handle.m_stream = handle;
}