#pragma once

#ifndef _WINDOWS_
#include <windows.h>
#endif


#ifndef Mutex
#define Mutex HANDLE		//!Done so we can abstract away the knowledge that a mutex is
							//!is really a windows handle.
#endif


/*!
	\name	class MutexObject

	\brief	A class that others can derive from that will give them a measure of thread
			safety via mutexes.

*/
class MutexObject
{

protected:

	//!A mutex for this object that is used for thread safety.
	mutable Mutex			m_mutex;
	
public:

	MutexObject(/* ... */)
	{
		//...
	}

	~MutexObject()
	{
		//release our mutex
		if(m_mutex)
		{
			//....
		}//endif
	}
	/*!
		\brief		Allows the caller to set the mutex of this class.

		\b Arguments:
		\arg 		???

		\return		Boolean return value. true good, false bad.

		\exception	NONE
	*/
	bool OpenMutex(/* ... */) const;

	/*!
		\brief		Allows the caller to release the mutex of this class.		

		\b Arguments:
		\arg 		???

		\return		boolean return value. true good, false bad.

		\exception	NONE
	*/
	bool ReleaseMutex(/* ... */) const;


	/*!
		\brief		Checks to see if the mutex is currently	avaible for use.

		\b Arguments:
		\arg 		???

		\return		boolean return value. true IS avaible, false NOT avaible.

		\exception	NONE
	*/
	bool IsMutexAvaible(/* ... */) const;

};